/* BaseCard.c generated by valac 0.56.13, the Vala compiler
 * generated from BaseCard.vala, do not modify */

/*
 * Copyright 2018–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authors: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define GREETER_BASE_CARD_ERROR_SHAKE_DURATION 450
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_TYPE_BASE_CARD (greeter_base_card_get_type ())
#define GREETER_BASE_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_BASE_CARD, GreeterBaseCard))
#define GREETER_BASE_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_BASE_CARD, GreeterBaseCardClass))
#define GREETER_IS_BASE_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_BASE_CARD))
#define GREETER_IS_BASE_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_BASE_CARD))
#define GREETER_BASE_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_BASE_CARD, GreeterBaseCardClass))

typedef struct _GreeterBaseCard GreeterBaseCard;
typedef struct _GreeterBaseCardClass GreeterBaseCardClass;
typedef struct _GreeterBaseCardPrivate GreeterBaseCardPrivate;
enum  {
	GREETER_BASE_CARD_0_PROPERTY,
	GREETER_BASE_CARD_CONNECTING_PROPERTY,
	GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY,
	GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY,
	GREETER_BASE_CARD_NUM_PROPERTIES
};
static GParamSpec* greeter_base_card_properties[GREETER_BASE_CARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GREETER_BASE_CARD_DO_CONNECT_SIGNAL,
	GREETER_BASE_CARD_NUM_SIGNALS
};
static guint greeter_base_card_signals[GREETER_BASE_CARD_NUM_SIGNALS] = {0};

struct _GreeterBaseCard {
	GtkRevealer parent_instance;
	GreeterBaseCardPrivate * priv;
};

struct _GreeterBaseCardClass {
	GtkRevealerClass parent_class;
	void (*wrong_credentials) (GreeterBaseCard* self);
};

struct _GreeterBaseCardPrivate {
	gboolean _connecting;
	gboolean _need_password;
	gboolean _use_fingerprint;
};

static gint GreeterBaseCard_private_offset;
static gpointer greeter_base_card_parent_class = NULL;
VALA_EXTERN GtkCssProvider* greeter_base_card_css_provider;
GtkCssProvider* greeter_base_card_css_provider = NULL;

VALA_EXTERN GType greeter_base_card_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterBaseCard, g_object_unref)
VALA_EXTERN void greeter_base_card_wrong_credentials (GreeterBaseCard* self);
static void greeter_base_card_real_wrong_credentials (GreeterBaseCard* self);
VALA_EXTERN GreeterBaseCard* greeter_base_card_construct (GType object_type);
VALA_EXTERN gboolean greeter_base_card_get_connecting (GreeterBaseCard* self);
VALA_EXTERN void greeter_base_card_set_connecting (GreeterBaseCard* self,
                                       gboolean value);
VALA_EXTERN gboolean greeter_base_card_get_need_password (GreeterBaseCard* self);
VALA_EXTERN void greeter_base_card_set_need_password (GreeterBaseCard* self,
                                          gboolean value);
VALA_EXTERN gboolean greeter_base_card_get_use_fingerprint (GreeterBaseCard* self);
VALA_EXTERN void greeter_base_card_set_use_fingerprint (GreeterBaseCard* self,
                                            gboolean value);
static GObject * greeter_base_card_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _greeter_base_card___lambda7_ (GreeterBaseCard* self);
static void __greeter_base_card___lambda7__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _greeter_base_card___lambda8_ (GreeterBaseCard* self);
static void __greeter_base_card___lambda8__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void greeter_base_card_finalize (GObject * obj);
static GType greeter_base_card_get_type_once (void);
static void _vala_greeter_base_card_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_greeter_base_card_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
greeter_base_card_get_instance_private (GreeterBaseCard* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterBaseCard_private_offset);
}

static void
greeter_base_card_real_wrong_credentials (GreeterBaseCard* self)
{
}

void
greeter_base_card_wrong_credentials (GreeterBaseCard* self)
{
	GreeterBaseCardClass* _klass_;
#line 59 "../src/Cards/BaseCard.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Cards/BaseCard.vala"
	_klass_ = GREETER_BASE_CARD_GET_CLASS (self);
#line 59 "../src/Cards/BaseCard.vala"
	if (_klass_->wrong_credentials) {
#line 59 "../src/Cards/BaseCard.vala"
		_klass_->wrong_credentials (self);
#line 149 "BaseCard.c"
	}
}

GreeterBaseCard*
greeter_base_card_construct (GType object_type)
{
	GreeterBaseCard * self = NULL;
#line 22 "../src/Cards/BaseCard.vala"
	self = (GreeterBaseCard*) g_object_new (object_type, NULL);
#line 22 "../src/Cards/BaseCard.vala"
	return self;
#line 161 "BaseCard.c"
}

gboolean
greeter_base_card_get_connecting (GreeterBaseCard* self)
{
	gboolean result;
#line 27 "../src/Cards/BaseCard.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/Cards/BaseCard.vala"
	result = self->priv->_connecting;
#line 27 "../src/Cards/BaseCard.vala"
	return result;
#line 174 "BaseCard.c"
}

void
greeter_base_card_set_connecting (GreeterBaseCard* self,
                                  gboolean value)
{
	gboolean old_value;
#line 27 "../src/Cards/BaseCard.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Cards/BaseCard.vala"
	old_value = greeter_base_card_get_connecting (self);
#line 27 "../src/Cards/BaseCard.vala"
	if (old_value != value) {
#line 27 "../src/Cards/BaseCard.vala"
		self->priv->_connecting = value;
#line 27 "../src/Cards/BaseCard.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_base_card_properties[GREETER_BASE_CARD_CONNECTING_PROPERTY]);
#line 192 "BaseCard.c"
	}
}

gboolean
greeter_base_card_get_need_password (GreeterBaseCard* self)
{
	gboolean result;
#line 28 "../src/Cards/BaseCard.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Cards/BaseCard.vala"
	result = self->priv->_need_password;
#line 28 "../src/Cards/BaseCard.vala"
	return result;
#line 206 "BaseCard.c"
}

void
greeter_base_card_set_need_password (GreeterBaseCard* self,
                                     gboolean value)
{
	gboolean old_value;
#line 28 "../src/Cards/BaseCard.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Cards/BaseCard.vala"
	old_value = greeter_base_card_get_need_password (self);
#line 28 "../src/Cards/BaseCard.vala"
	if (old_value != value) {
#line 28 "../src/Cards/BaseCard.vala"
		self->priv->_need_password = value;
#line 28 "../src/Cards/BaseCard.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_base_card_properties[GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY]);
#line 224 "BaseCard.c"
	}
}

gboolean
greeter_base_card_get_use_fingerprint (GreeterBaseCard* self)
{
	gboolean result;
#line 29 "../src/Cards/BaseCard.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Cards/BaseCard.vala"
	result = self->priv->_use_fingerprint;
#line 29 "../src/Cards/BaseCard.vala"
	return result;
#line 238 "BaseCard.c"
}

void
greeter_base_card_set_use_fingerprint (GreeterBaseCard* self,
                                       gboolean value)
{
	gboolean old_value;
#line 29 "../src/Cards/BaseCard.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Cards/BaseCard.vala"
	old_value = greeter_base_card_get_use_fingerprint (self);
#line 29 "../src/Cards/BaseCard.vala"
	if (old_value != value) {
#line 29 "../src/Cards/BaseCard.vala"
		self->priv->_use_fingerprint = value;
#line 29 "../src/Cards/BaseCard.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_base_card_properties[GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY]);
#line 256 "BaseCard.c"
	}
}

static void
_greeter_base_card___lambda7_ (GreeterBaseCard* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 47 "../src/Cards/BaseCard.vala"
	_tmp0_ = gtk_revealer_get_child_revealed ((GtkRevealer*) self);
#line 47 "../src/Cards/BaseCard.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/Cards/BaseCard.vala"
	if (!_tmp1_) {
#line 48 "../src/Cards/BaseCard.vala"
		gtk_widget_set_visible ((GtkWidget*) self, FALSE);
#line 273 "BaseCard.c"
	}
}

static void
__greeter_base_card___lambda7__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 46 "../src/Cards/BaseCard.vala"
	_greeter_base_card___lambda7_ ((GreeterBaseCard*) self);
#line 284 "BaseCard.c"
}

static void
_greeter_base_card___lambda8_ (GreeterBaseCard* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 53 "../src/Cards/BaseCard.vala"
	_tmp0_ = gtk_revealer_get_reveal_child ((GtkRevealer*) self);
#line 53 "../src/Cards/BaseCard.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/Cards/BaseCard.vala"
	if (_tmp1_) {
#line 54 "../src/Cards/BaseCard.vala"
		gtk_widget_set_visible ((GtkWidget*) self, TRUE);
#line 300 "BaseCard.c"
	}
}

static void
__greeter_base_card___lambda8__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 52 "../src/Cards/BaseCard.vala"
	_greeter_base_card___lambda8_ ((GreeterBaseCard*) self);
#line 311 "BaseCard.c"
}

static GObject *
greeter_base_card_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterBaseCard * self;
	GdkEventMask _tmp0_;
	GdkEventMask _tmp1_;
#line 38 "../src/Cards/BaseCard.vala"
	parent_class = G_OBJECT_CLASS (greeter_base_card_parent_class);
#line 38 "../src/Cards/BaseCard.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/Cards/BaseCard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_BASE_CARD, GreeterBaseCard);
#line 39 "../src/Cards/BaseCard.vala"
	g_object_set ((GtkWidget*) self, "width-request", 350, NULL);
#line 40 "../src/Cards/BaseCard.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
#line 41 "../src/Cards/BaseCard.vala"
	gtk_revealer_set_transition_type ((GtkRevealer*) self, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 42 "../src/Cards/BaseCard.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 43 "../src/Cards/BaseCard.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 44 "../src/Cards/BaseCard.vala"
	_tmp0_ = gtk_widget_get_events ((GtkWidget*) self);
#line 44 "../src/Cards/BaseCard.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/Cards/BaseCard.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp1_ | GDK_BUTTON_RELEASE_MASK);
#line 46 "../src/Cards/BaseCard.vala"
	g_signal_connect_object ((GObject*) self, "notify::child-revealed", (GCallback) __greeter_base_card___lambda7__g_object_notify, self, 0);
#line 52 "../src/Cards/BaseCard.vala"
	g_signal_connect_object ((GObject*) self, "notify::reveal-child", (GCallback) __greeter_base_card___lambda8__g_object_notify, self, 0);
#line 38 "../src/Cards/BaseCard.vala"
	return obj;
#line 352 "BaseCard.c"
}

static void
greeter_base_card_class_init (GreeterBaseCardClass * klass,
                              gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 22 "../src/Cards/BaseCard.vala"
	greeter_base_card_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Cards/BaseCard.vala"
	g_type_class_adjust_private_offset (klass, &GreeterBaseCard_private_offset);
#line 22 "../src/Cards/BaseCard.vala"
	((GreeterBaseCardClass *) klass)->wrong_credentials = (void (*) (GreeterBaseCard*)) greeter_base_card_real_wrong_credentials;
#line 22 "../src/Cards/BaseCard.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_greeter_base_card_get_property;
#line 22 "../src/Cards/BaseCard.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_greeter_base_card_set_property;
#line 22 "../src/Cards/BaseCard.vala"
	G_OBJECT_CLASS (klass)->constructor = greeter_base_card_constructor;
#line 22 "../src/Cards/BaseCard.vala"
	G_OBJECT_CLASS (klass)->finalize = greeter_base_card_finalize;
#line 22 "../src/Cards/BaseCard.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_BASE_CARD_CONNECTING_PROPERTY, greeter_base_card_properties[GREETER_BASE_CARD_CONNECTING_PROPERTY] = g_param_spec_boolean ("connecting", "connecting", "connecting", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Cards/BaseCard.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY, greeter_base_card_properties[GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY] = g_param_spec_boolean ("need-password", "need-password", "need-password", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Cards/BaseCard.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY, greeter_base_card_properties[GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY] = g_param_spec_boolean ("use-fingerprint", "use-fingerprint", "use-fingerprint", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Cards/BaseCard.vala"
	greeter_base_card_signals[GREETER_BASE_CARD_DO_CONNECT_SIGNAL] = g_signal_new ("do-connect", GREETER_TYPE_BASE_CARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 34 "../src/Cards/BaseCard.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 34 "../src/Cards/BaseCard.vala"
	_g_object_unref0 (greeter_base_card_css_provider);
#line 34 "../src/Cards/BaseCard.vala"
	greeter_base_card_css_provider = _tmp0_;
#line 35 "../src/Cards/BaseCard.vala"
	_tmp1_ = greeter_base_card_css_provider;
#line 35 "../src/Cards/BaseCard.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/greeter/Card.css");
#line 393 "BaseCard.c"
}

static void
greeter_base_card_instance_init (GreeterBaseCard * self,
                                 gpointer klass)
{
#line 22 "../src/Cards/BaseCard.vala"
	self->priv = greeter_base_card_get_instance_private (self);
#line 27 "../src/Cards/BaseCard.vala"
	self->priv->_connecting = FALSE;
#line 28 "../src/Cards/BaseCard.vala"
	self->priv->_need_password = FALSE;
#line 29 "../src/Cards/BaseCard.vala"
	self->priv->_use_fingerprint = FALSE;
#line 408 "BaseCard.c"
}

static void
greeter_base_card_finalize (GObject * obj)
{
	GreeterBaseCard * self;
#line 22 "../src/Cards/BaseCard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_BASE_CARD, GreeterBaseCard);
#line 22 "../src/Cards/BaseCard.vala"
	G_OBJECT_CLASS (greeter_base_card_parent_class)->finalize (obj);
#line 419 "BaseCard.c"
}

static GType
greeter_base_card_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterBaseCardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_base_card_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterBaseCard), 0, (GInstanceInitFunc) greeter_base_card_instance_init, NULL };
	GType greeter_base_card_type_id;
	greeter_base_card_type_id = g_type_register_static (gtk_revealer_get_type (), "GreeterBaseCard", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GreeterBaseCard_private_offset = g_type_add_instance_private (greeter_base_card_type_id, sizeof (GreeterBaseCardPrivate));
	return greeter_base_card_type_id;
}

GType
greeter_base_card_get_type (void)
{
	static volatile gsize greeter_base_card_type_id__once = 0;
	if (g_once_init_enter (&greeter_base_card_type_id__once)) {
		GType greeter_base_card_type_id;
		greeter_base_card_type_id = greeter_base_card_get_type_once ();
		g_once_init_leave (&greeter_base_card_type_id__once, greeter_base_card_type_id);
	}
	return greeter_base_card_type_id__once;
}

static void
_vala_greeter_base_card_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GreeterBaseCard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_TYPE_BASE_CARD, GreeterBaseCard);
#line 22 "../src/Cards/BaseCard.vala"
	switch (property_id) {
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_CONNECTING_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		g_value_set_boolean (value, greeter_base_card_get_connecting (self));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		g_value_set_boolean (value, greeter_base_card_get_need_password (self));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		g_value_set_boolean (value, greeter_base_card_get_use_fingerprint (self));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 472 "BaseCard.c"
		default:
#line 22 "../src/Cards/BaseCard.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 478 "BaseCard.c"
	}
}

static void
_vala_greeter_base_card_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GreeterBaseCard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_TYPE_BASE_CARD, GreeterBaseCard);
#line 22 "../src/Cards/BaseCard.vala"
	switch (property_id) {
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_CONNECTING_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		greeter_base_card_set_connecting (self, g_value_get_boolean (value));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_NEED_PASSWORD_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		greeter_base_card_set_need_password (self, g_value_get_boolean (value));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 22 "../src/Cards/BaseCard.vala"
		case GREETER_BASE_CARD_USE_FINGERPRINT_PROPERTY:
#line 22 "../src/Cards/BaseCard.vala"
		greeter_base_card_set_use_fingerprint (self, g_value_get_boolean (value));
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 510 "BaseCard.c"
		default:
#line 22 "../src/Cards/BaseCard.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Cards/BaseCard.vala"
		break;
#line 516 "BaseCard.c"
	}
}

